/*
 *  Copyright 2010-2013, Plutext Pty Ltd.
 *
 *  This file is part of xlsx4j, a component of docx4j.

    docx4j is licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.

    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

 */
package org.xlsx4j.sml;

import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import org.xlsx4j.jaxb.Context;
import com.openexchange.office.filter.core.component.Child;


/**
 * <p>Java class for CT_NumFmt complex type.
 *
 * <p>The following schema fragment specifies the expected content contained within this class.
 *
 * <pre>
 * &lt;complexType name="CT_NumFmt">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;attribute name="numFmtId" use="required" type="{http://schemas.openxmlformats.org/spreadsheetml/2006/main}ST_NumFmtId" />
 *       &lt;attribute name="formatCode" use="required" type="{http://schemas.openxmlformats.org/officeDocument/2006/sharedTypes}ST_Xstring" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 *
 *
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_NumFmt")
public class CTNumFmt implements Cloneable
{

    @XmlAttribute(name = "numFmtId", required = true)
    protected long numFmtId;
    @XmlAttribute(name = "formatCode", required = true)
    protected String formatCode;

    public CTNumFmt clone() {
    	final CTNumFmt clone = Context.getsmlObjectFactory().createCTNumFmt();
    	clone.setNumFmtId(numFmtId);
    	clone.setFormatCode(formatCode);
    	return clone;
    }
    /**
     * Gets the value of the numFmtId property.
     *
     */
    public long getNumFmtId() {
        return numFmtId;
    }

    /**
     * Sets the value of the numFmtId property.
     *
     */
    public void setNumFmtId(long value) {
        this.numFmtId = value;
    }

    /**
     * Gets the value of the formatCode property.
     *
     * @return
     *     possible object is
     *     {@link String }
     *
     */
    public String getFormatCode() {
        return formatCode;
    }

    /**
     * Sets the value of the formatCode property.
     *
     * @param value
     *     allowed object is
     *     {@link String }
     *
     */
    public void setFormatCode(String value) {
        this.formatCode = value;
    }
}
